//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import "colors.h"

@implementation colors

-init
{
    [super init];
    // Color estados
    sourceColor1 = [[NSColor colorWithCalibratedRed:1 green:100 blue:0 alpha:100] retain];
    sourceColor2 = [[NSColor colorWithCalibratedRed:1 green:0 blue:0 alpha:100] retain];
    // Color ether
    etherZero = [[NSColor colorWithCalibratedRed:1 green:100 blue:50 alpha:100] retain];
    etherOne = [[NSColor colorWithCalibratedRed:1 green:50 blue:0 alpha:100] retain];
    return self;
}

// Get handles to the wells and read their initial colors.
- (void)setSourceColorOne:(id)anObject 
{
   sourceColorOne = anObject;
   sourceColor1 = [[anObject color] copyWithZone:[self zone]];
}

// The following methods change the colors and update
// the source or destination bitmaps and the view to reflect the change.
// They should typically be called by a control capable of returning
// a color (for instance, an NSColorWell).
- (void)changeSourceColorOne:(id)sender
{
   [self changeSourceColorOneTo:[sender color]];
}

- (void)changeSourceColorOneTo:(NSColor *)color
{
    if (![sourceColor1 isEqual:color])
    {
        [sourceColor1 release];
        sourceColor1 = [color copyWithZone:[self zone]];
    }
}

-(NSColor *)sendColor1
{
    NSColor *color;
    color = sourceColor1;
    return color;
}

// Color Two

- (void)setSourceColorTwo:(id)anObject
{
   sourceColorTwo = anObject;
   sourceColor2 = [[anObject color] copyWithZone:[self zone]];
}

- (void)changeSourceColorTwo:(id)sender
{
   [self changeSourceColorTwoTo:[sender color]];
}

- (void)changeSourceColorTwoTo:(NSColor *)color
{
    if (![sourceColor2 isEqual:color])
    {
        [sourceColor2 release];
        sourceColor2 = [color copyWithZone:[self zone]];
    }
}

-(NSColor *)sendColor2
{
    NSColor *color;
    color = sourceColor2;
    return color;
}

// Color ether zero

- (void)setSourceColorEtherZero:(id)anObject
{
    zeroEther = anObject;
    etherZero = [[anObject color] copyWithZone:[self zone]];
}

- (void)changeSourceColorEtherZero:(id)sender
{
    [self changeSourceColorEtherZeroTo:[sender color]];
}

- (void)changeSourceColorEtherZeroTo:(NSColor *)color
{
    if (![etherZero isEqual:color])
      {
        [etherZero release];
        etherZero = [color copyWithZone:[self zone]];
      }
}

-(NSColor *)sendEtherZero
{
    NSColor *color;
    color = etherZero;
    return color;
}

// Ether one

- (void)setSourceColorOneZero:(id)anObject
{
    oneEther = anObject;
    etherOne = [[anObject color] copyWithZone:[self zone]];
}

- (void)changeSourceColorEtherOne:(id)sender
{
    [self changeSourceColorEtherOneTo:[sender color]];
}

- (void)changeSourceColorEtherOneTo:(NSColor *)color
{
    if (![etherOne isEqual:color])
      {
        [etherOne release];
        etherOne = [color copyWithZone:[self zone]];
      }
}

-(NSColor *)sendEtherOne
{
    NSColor *color;
    color = etherOne;
    return color;
}

@end
