//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import "control.h"
int initial_ringControl[1152];
int evolutionControl[864][1152];
int _RING;
int _LINES;
int _SIZE;

@implementation control

-(void)initOwner:(id)sender;
{
    int ring;
    int lines;
    int size;

    // Capturar altura y ancho del view
    ring = [view_evolution widthView];
    lines = [view_evolution heightView];
    // Capturar tamano de la celula
    size = [class_operations sizeCell:ring:lines];
    // RING y LINES recalculados
    ring = [class_operations newRing];
    lines = [class_operations newLines];
    // Definir colores de los estados
    color1 = [class_colors sendColor1];
    color2 = [class_colors sendColor2];
    _RING = ring;
    _LINES = lines;
    _SIZE = size;
}

// Boton configuracion inicial
-(void)initialConfiguration:(id)sender
{
    int i;

    [self initOwner:self];
    [class_operations initialconfiguration:_RING];
    // Capturar configuracion inicial
    for(i=0;i<_RING;i++)
      {
        initial_ringControl[i] = [class_operations captureConfigurationInitial:i];
        [view_evolution sendInitialConfiguration:i:initial_ringControl[i]];
      }
    // Dibujar configuracion aleatoria
    [view_evolution drawInitialConfiguration:_RING:_LINES:_SIZE:color1:color2];
}

// Boton evolucion
-(void)evolutionSpace:(id)sender
{
    int i;
    int j;

    [class_operations makeEvolution:_RING:_LINES];
    for(i=0;i<_LINES;i++)
      {
        for(j=0;j<_RING;j++)
          {
            evolutionControl[i][j] = [class_operations captureEvolution:i:j];
            [view_evolution sendEvolution:i:j:evolutionControl[i][j]];
          }
      }
    // Dibujar evolucion
    [view_evolution drawEvolution:_RING:_LINES:_SIZE];
}

// Boton continuar evolucion
-(void)continueEvolution:(id)sender
{
    int i;
    int j;

    [class_operations evolutionContinue:_RING:_LINES];
    for(i=0;i<_LINES;i++)
      {
        for(j=0;j<_RING;j++)
          {
            evolutionControl[i][j] = [class_operations captureEvolution:i:j];
            [view_evolution sendEvolution:i:j:evolutionControl[i][j]];
          }
      }
    [view_evolution viewClear];
    [view_evolution drawEvolution:_RING:_LINES:_SIZE];
}

// Boton limpiar vista
-(void)clearView:(id)sender
{
    [view_evolution viewClear];
    [class_operations clearVar];
}

// Arreglo de botones para los gliders
-(void)gliderType:(id)sender
{
    int i;
    int numbertag;

    [self initOwner:self];
    // Capturar el tag del glider
    numbertag = [[sender selectedCell] tag];
    [class_operations typeGlider:numbertag:_RING];
    // Capturar configuracion inicial
    for(i=0;i<_RING;i++)
      {
        initial_ringControl[i] = [class_operations captureConfigurationInitial:i];
        [view_evolution sendInitialConfiguration:i:initial_ringControl[i]];
      }
    // Dibujar configuracion aleatoria
    [view_evolution drawInitialConfiguration:_RING:_LINES:_SIZE:color1:color2];
}

// Pintar ether
-(void)paintEther:(id)sender;
{
   // Definir colores del ether
   color3 = [class_colors sendEtherZero];
   color4 = [class_colors sendEtherOne];
   [view_evolution etherPaint:_RING:_LINES:_SIZE:color3:color4];
}

@end
