//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import <AppKit/AppKit.h>

@interface evolution : NSView
{
    NSColor *colorOne;
    NSColor *colorTwo;
    NSColor *colorEtherZero;
    NSColor *colorEtherOne;
}

// Reviza frontera izquierda
int check_Inf(int k,int ring);

// Reviza frontera derecha
int check_Right(int k,int ring);

// Inicializa la grafica
- initWithFrame:(NSRect)rects;

// Dibuja la grafica
-(void)drawRect:(NSRect)rects;

// Ancho del view
-(int)widthView;

// Altura del view
-(int)heightView;

// Diduja la configuracion inicial
-(void)drawInitialConfiguration:(int)ring:(int)lines:(int)size:(NSColor *)uno:(NSColor *)dos;

// Dibuja una celula
-(void)drawPoint:(int)x:(int)y:(int)size:(NSColor *)color;

// Captura configuracion inicial
-(void)sendInitialConfiguration:(int)i:(int)column;

// Limpia la vista
-(void)viewClear;

// Captura evolucion
-(void)sendEvolution:(int)row:(int)column:(int)cell;

// Dibuja evolucion
-(void)drawEvolution:(int)ring:(int)lines:(int)size;

// Pintar ether
-(void)etherPaint:(int)ring:(int)lines:(int)size:(NSColor *)uno:(NSColor *)dos;

@end

