//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import "evolution.h"
int longx;
int longy;
int initial_ringEvolution[1152];
int evolutionEvolution[864][1152];

// Reviza frontera izquierda
int check_Inf(int k,int lines)
{
   if(k>lines-1)
       k -= lines;
   return(k);
}

// Reviza frontera derecha
int check_Right(int k,int ring)
{
  if(k>ring-1)
      k -= ring;
  return(k);
}

@implementation evolution

// Inicializa la grafica
- initWithFrame:(NSRect)rects;
{
    [super initWithFrame:rects];
    [self allocateGState];
    // Color ether
    colorEtherZero = [[NSColor colorWithCalibratedRed:1 green:100 blue:50 alpha:100] retain];
    colorEtherOne = [[NSColor colorWithCalibratedRed:1 green:50 blue:0 alpha:100] retain];
    // Color estados
    colorOne = [[NSColor colorWithCalibratedRed:1 green:100 blue:0 alpha:100] retain];
    colorTwo = [[NSColor colorWithCalibratedRed:1 green:0 blue:0 alpha:100] retain];
    return self;    
}

// Dibuja la grafica
-(void)drawRect:(NSRect)rects;
{
    /*Limites del cuadro*/
    NSRect limites=[self bounds];
    longx=limites.size.width;
    longy=limites.size.height;
    [[NSColor whiteColor] set];
    NSRectFill([self bounds]);
}

// Ancho del view
-(int)widthView
{
    [self display];
    return longx;
}

// Altura del view
-(int)heightView
{
   [self display];
   return longy;
}

// Captura configuracion inicial
-(void)sendInitialConfiguration:(int)i:(int)column
{
    initial_ringEvolution[i] = column;
}

// Dibuja una celula
-(void)drawPoint:(int)x:(int)y:(int)size:(NSColor *)color
{
    PSnewpath();
    [color set];
    if(size>=5)
        PSrectfill(x,y,size-1,size-1);
    else
        PSrectfill(x,y,size,size);
    PSfill();
    PSstroke();
}

// Diduja la configuracion inicial
-(void)drawInitialConfiguration:(int)ring:(int)lines:(int)size:(NSColor *)uno:(NSColor *)dos
{
    int i;
    int j;

    colorOne = uno;
    colorTwo = dos;
    [self lockFocus];
    for(i=0,j=0;i<ring;i++,j+=size)
    {
        if(initial_ringEvolution[i]==0)
            [self drawPoint:j:longy-size:size:colorOne];
        if(initial_ringEvolution[i]==1)
            [self drawPoint:j:longy-size:size:colorTwo];
    }
    /*Pinta al momento de generar la celula*/
    [[self window] flushWindow];
    [self unlockFocus];
}

// Limpia la vista
-(void)viewClear
{
    [self display];
}

// Captura evolucion
-(void)sendEvolution:(int)row:(int)column:(int)cell
{
    evolutionEvolution[row][column] = cell;
}

// Dibuja evolucion
-(void)drawEvolution:(int)ring:(int)lines:(int)size
{
    int i;
    int j;
    int flag;
    int increment;

    [self lockFocus];
    for(i=0,increment=size;i<lines;i++,increment+=size)
      {
        for(j=0,flag=0;j<ring;j++,flag+=size)
          {
            if(evolutionEvolution[i][j]==0)
               [self drawPoint:flag:longy-increment:size:colorOne];
            if(evolutionEvolution[i][j]==1)
               [self drawPoint:flag:longy-increment:size:colorTwo];
          }
        [[self window] flushWindow];
      }
    [self unlockFocus];
}

// Pintar ether
-(void)etherPaint:(int)ring:(int)lines:(int)size:(NSColor *)uno:(NSColor *)dos
{
    int i;
    int j;
    int k=0;
    int flag;
    int aux;
    int increment;

    colorEtherZero = uno;
    colorEtherOne = dos;
    [self lockFocus];
    for(i=0,increment=size;i<lines;i++,increment+=size)
      {
        for(j=0,flag=0,aux=0;j<ring;j++,aux+=size)
          { // Ether original
            if(evolutionEvolution[i][j]==1 && 
               evolutionEvolution[i][check_Right(j+1,ring)]==1 && 
               evolutionEvolution[i][check_Right(j+2,ring)]==1 && 
               evolutionEvolution[i][check_Right(j+3,ring)]==1)
              {
                if(evolutionEvolution[check_Inf(i+1,lines)][j]==1 && 
                   evolutionEvolution[check_Inf(i+1,lines)][check_Right(j+1,ring)]==0 && 
                   evolutionEvolution[check_Inf(i+1,lines)][check_Right(j+2,ring)]==0 && 
                   evolutionEvolution[check_Inf(i+1,lines)][check_Right(j+3,ring)]==0)
                  {
                    if(evolutionEvolution[check_Inf(i+2,lines)][j]==1 && 
                       evolutionEvolution[check_Inf(i+2,lines)][check_Right(j+1,ring)]==0 && 
                       evolutionEvolution[check_Inf(i+2,lines)][check_Right(j+2,ring)]==0 && 
                       evolutionEvolution[check_Inf(i+2,lines)][check_Right(j+3,ring)]==1)
                      {
                        if(evolutionEvolution[check_Inf(i+3,lines)][j]==1 && 
                           evolutionEvolution[check_Inf(i+3,lines)][check_Right(j+1,ring)]==0)
                          { /* Margin above left
                            if(evolutionEvolution[i][j-1]==0 &&
                               evolutionEvolution[i]][j-2]==1)
                               evolutionEvolution[i-1][j+1]==1 &&
                               evolutionEvolution[i-1][j]==0 &&
			       evolutionEvolution[i-1][j-1]==0 &&
			       evolutionEvolution[i-1][j-2]==1 &&
                               evolutionEvolution[i-1][j-2]==1 &&*/

          		    // Paint ether
                            flag = aux;
                            for(k=0;k<4;k++,flag+=size)
                              {
                                if(evolutionEvolution[i][check_Right(j+k,ring)]==1)
                                    [self drawPoint:flag:longy-increment:size:colorEtherOne];
                                else
                                    [self drawPoint:flag:longy-increment:size:colorEtherZero];
                                if(evolutionEvolution[check_Inf(i+1,lines)][check_Right(j+k,ring)]==1)
                                    [self drawPoint:flag:longy-(increment+size):size:colorEtherOne];
                                else
                                    [self drawPoint:flag:longy-(increment+size):size:colorEtherZero];
                                if(evolutionEvolution[check_Inf(i+2,lines)][check_Right(j+k,ring)]==1)
                                    [self drawPoint:flag:longy-(increment+(size*2)):size:colorEtherOne];
                                else
                                    [self drawPoint:flag:longy-(increment+(size*2)):size:colorEtherZero];
                                if(k<2)
                                  {
                                    if(evolutionEvolution[check_Inf(i+3,lines)][check_Right(j+k,ring)]==1)
                                        [self drawPoint:flag:longy-(increment+(size*3)):size:colorEtherOne];
                                    else
                                        [self drawPoint:flag:longy-(increment+(size*3)):size:colorEtherZero];
                                  }
                              }
                          }
                      }
                  }
              }
            }
            [[self window] flushWindow];
        }
	[self unlockFocus];
}

@end
