//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import "operations.h"
int SIZE;
int RING;
int LINES;
int counter;
int initial_ring[1152];
int evolution[864][1152];
int neighborhood[8];
int posY = 0;
int first = 1;

// Convierte decimal en binario
int rule_binary(int ruleaux)
{
    int modulo;
    int divisor;
    int i=0;
    do
      {
          modulo = fmod(ruleaux,2);
          divisor = ruleaux/2;
          neighborhood[i] = modulo;
          ruleaux = divisor;
          i++;
      }while(i<8);
    return 0;
}

// Reviza frontera izquierda
int check_left(int k,int ring)
{
    int help;
    help = k;
    if(k<0)
        help = ring - 1;
    if(k>ring-1)
        help = k - ring;
    return(help);
}

// Reviza frontera derecha
int check_right(int k,int ring)
{
    if(k>ring-1)
        k -= ring;
    return(k);
}

@implementation operations

// Configuracion aleatoria
-(void)initialconfiguration:(int)ring
{
    int i;
    float y;
    float flag=0;
    time_t seconds;

    posY = 0;
    first = 1;
    flag = [density floatValue];
    time(&seconds);
    srand((unsigned)(seconds % 65536));
    for(i=0;i<ring;i++)
      {
        y = rand()/pow(2,31);
        if(y>flag)
            initial_ring[i] = 0;
        else
            initial_ring[i] = 1;
      }
}

// Capturar configuracion inicial
-(int)captureConfigurationInitial:(int)column
{
    return initial_ring[column];
}

// Tamano de la celula
-(int)sizeCell:(int)ring:(int)lines
{
    [self sizeCells:ring:lines];
    return SIZE;
}

// RING recalculado
-(int)newRing
{
    return RING;
}

// LINES recalculado
-(int)newLines
{
    return LINES;
}

// Determina el tamano de celula
-(void)sizeCells:(int)ring:(int)lines
{
    RING = ring;
    LINES = lines;
    SIZE = [size_cell intValue];
    /*Configuracion chica*/
    switch(SIZE)
    {
        case 1:
            ring=RING;
            lines=LINES;
            break;
        case 2:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 3:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 4:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 5:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 6:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 7:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 8:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 9:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
        case 10:
            ring=RING/SIZE;
            lines=LINES/SIZE;
            break;
    }
    RING = ring;
    LINES = lines;
}

// Captura evolucion
-(int)captureEvolution:(int)row:(int)column
{
    return evolution[row][column];
}

// Calcular evolucion
-(void)makeEvolution:(int)ring:(int)lines
{
    int i;
    int j;
    int ruledec;
    int tmp;
    int aux[ring];

    counter = 0;
    ruledec = [rule_evolution intValue];
    rule_binary(ruledec);
    for(i=0;i<ring;i++)
        evolution[0][i] = aux[i] = initial_ring[i];
    // Calcula la evolucion
    for(i=1;i<lines;i++)
      {
        // Calcula la siguiente evolucion
        for(j=0;j<ring;j++)
          {
            tmp = aux[check_left(j-1,ring)]*4 + aux[j]*2 + aux[check_right(j+1,ring)];
            evolution[i][j] = neighborhood[tmp];
          }
        for(j=0;j<ring;j++)
            aux[j] = evolution[i][j];
      }
    [cells setIntValue:ring];
    [evolutions setIntValue:lines];
    counter = lines;
}

// Continuar la evolucion
-(void)evolutionContinue:(int)ring:(int)lines
{
    int i;
    int j;
    int ruledec;
    int tmp;
    int aux[ring];

    counter += lines;
    ruledec = [rule_evolution intValue];
    rule_binary(ruledec);
    for(i=0;i<ring;i++)
    {
        aux[i] = evolution[lines-1][i];
        evolution[0][i] = evolution[lines-1][i];
    }
    // Calcula la evolucion
    for(i=1;i<lines;i++)
      {
        // Calcula la siguiente evolucion
        for(j=0;j<ring;j++)
          {
            tmp = aux[check_left(j-1,ring)]*4 + aux[j]*2 + aux[check_right(j+1,ring)];
            evolution[i][j] = neighborhood[tmp];
          }
        for(j=0;j<ring;j++)
            aux[j] = evolution[i][j];
      }
    [cells setIntValue:ring];
    [evolutions setIntValue:counter];
}

// Limpia variables y el view
-(void)clearVar
{
   posY = 0;
   first = 1;
}

// Captura el glider activado
- (void)typeGlider:(int)numbertag:(int)ring
{
    int i;

    // Revisar que sea la primera vez
    if(first == 1)
      {
        first = 0;
        for(i=0;i<ring;i++)
            initial_ring[i] = 0;
      }
    if(posY < ring)
      {
        switch(numbertag)
          {
                // ether 11111000100110 (14) (fase 1)
            case 0:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                posY = posY + 14;
                break;
                // ether 10001001101111 (14) (fase 2)
            case 1:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                posY = posY + 14;
                break;
                // ether 10011011111000 (14) (fase 3)
            case 2:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                posY = posY + 14;
                break;
                // ether alpha 10111110001001 (14) (fase 4)
            case 3:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                posY = posY + 14;
                break;

                // glider A 111110 (6) (fase 1)
            case 50:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                posY = posY + 6;
                break;
                // glider A 100011 (6) (fase 2)
            case 51:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                posY = posY + 6;
                break;
                // glider A 100110 (6) (fase 3)
            case 52:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                posY = posY + 6;
                break;
                // glider A 101111 (6) (fase 4)
            case 53:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                posY = posY + 6;
                break;

                // glider B 11111010 (8) (fase 1)
            case 100:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                posY = posY + 8;
                break;
                // glider B 10001111 (8) (fase 2)
            case 101:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                posY = posY + 8;
                break;
                // glider B 10011000 (8) (fase 3)
            case 102:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                posY = posY + 8;
                break;
                // glider B 10111001 (8) (fase 4)
            case 103:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                posY = posY + 8;
                break;
                
                // glider B-bar 1111100010110111100110 (22) (fase 1)
            case 150:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                posY = posY + 22;
                break;
                // glider B-bar 1000100111111100101111 (22) (fase 2)
            case 151:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                posY = posY + 22;
                break;
                // glider B-bar 1001101100000101111000 (22) (fase 3)
            case 152:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                posY = posY + 22;
                break;
                // glider B-bar 1011111100001111001001 (22) (fase 4)
            case 153:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                posY = posY + 22;
                break;
                // glider B-bar 1111100001000110010110 (22) (fase 1)
            case 154:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                posY = posY + 22;
                break;
                // glider B-bar 1000100011001110111111 (22) (fase 2)
            case 155:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                posY = posY + 22;
                break;
                // glider B-bar 1001100111011011100000 (22) (fase 3)
            case 156:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                posY = posY + 22;
                break;
                // glider B-bar 1011101101111110100001 (22) (fase 4)
            case 157:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                posY = posY + 22;
                break;
                // glider B-bar 1111101111110000111000 (22) (fase 1)
            case 158:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                posY = posY + 22;
                break;
                // glider B-bar 1000111000010001101001 (22) (fase 2)
            case 159:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                posY = posY + 22;
                break;
                // glider B-bar 1001101000110011111011 (22) (fase 3)
            case 160:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                posY = posY + 22;
                break;
                // glider B-bar 1011111001110110001110 (22) (fase 4)
            case 161:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                posY = posY + 22;
                break;

// glider B-bar8 111110001011011110011001111111000100110 (39) (fase 1)
            case 800:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
// glider B-bar8 100010011111110010111011000001001101111 (39) (fase 2)
            case 801:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
// glider B-bar8 100110110000010111101111000011011111000 (39) (fase 3)
            case 802:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
// glider B-bar8 101111110000111100111001000111110001001 (39) (fase 4)
            case 803:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
// glider B-bar8 111110000100011001011010110011000100110 (39) (fase 1)
            case 804:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
// glider B-bar8 100010001100111011111111110111001101111 (39) (fase 2)
            case 805:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
// glider B-bar8 100110011101101110000000011101011111000 (39) (fase 3)
            case 806:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
// glider B-bar8 101110110111111010000000110111110001001 (39) (fase 4)
            case 807:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
// glider B-bar8 111110111111000011100000011111000100110 (39) (fase 1)
            case 808:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
// glider B-bar8 100011100001000110100000110001001101111 (39) (fase 2)
            case 809:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
// glider B-bar8 100110100011001111100001110011011111000 (39) (fase 3)
            case 810:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
// glider B-bar8 101111100111011000100011010111110001001 (39) (fase 4)
            case 811:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;

                // glider C1 11111011010 (11) (fase 1)
            case 200:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;
                // glider C1 10001111111 (11) (fase 2)
            case 201:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
                // glider C1 10011000000 (11) (fase 3)
            case 202:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;
                // glider C1 10111000001 (11) (fase 4)
            case 203:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
                // glider C1 11111010000 (11) (fase 1)
            case 204:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;
                // glider C1 10001110001 (11) (fase 2)
            case 205:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
                // glider C1 10011010011 (11) (fase 3)
            case 206:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
                // glider C1 10111110110 (11) (fase 4)
            case 207:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;

                // glider C2 11111000000100110 (17) (fase 1)
            case 250:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                posY = posY + 17;
                break;
                // glider C2 10001000001101111 (17) (fase 2)
            case 251:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                posY = posY + 17;
                break;
                // glider C2 10011000011111000 (17) (fase 3)
            case 252:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                posY = posY + 17;
                break;
                // glider C2 10111000110001001 (17) (fase 4)
            case 253:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                posY = posY + 17;
                break;
                // glider C2 11111010011100110 (17) (fase 1)
            case 254:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                posY = posY + 17;
                break;
                // glider C2 10001110110101111 (17) (fase 2)
            case 255:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                posY = posY + 17;
                break;
                // glider C2 10011011111111000 (17) (fase 3)
            case 256:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                posY = posY + 17;
                break;
                // glider C2 10111110000001001 (17) (fase 4)
            case 257:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                posY = posY + 17;
                break;

                // glider C3 111110000 (9) (fase 1)
            case 300:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                posY = posY + 9;
                break;
                // glider C3 100010001 (9) (fase 2)
            case 301:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                posY = posY + 9;
                break;
		// glider C3 100110011 (9) (fase 3)
            case 302:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                posY = posY + 9;
                break;
		// glider C3 101110110 (9) (fase 4)
            case 303:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                posY = posY + 9;
                break;
		// glider C3 11111011111111000100110 (23) (fase 1)
            case 304:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                posY = posY + 23;
                break;
		// glider C3 10001110000001001101111 (23) (fase 2)
            case 305:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                posY = posY + 23;
                break;
		// glider C3 10011010000011011111000 (23) (fase 3)
            case 306:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                posY = posY + 23;
                break;
		// glider C3 10111110000111110001001 (23) (fase 4)
            case 307:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                posY = posY + 23;
                break;

                // glider D1 1111101011000100110 (19) (fase 1)
            case 350:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider D1 1000111111001101111 (19) (fase 2)
            case 351:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider D1 1001100001011111000 (19) (fase 3)
            case 352:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider D1 1011100011110001001 (19) (fase 4)
            case 353:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider D1 1111101001100100110 (19) (fase 1)
            case 354:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider D1 1000111011101101111 (19) (fase 2)
            case 355:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider D1 1001101110111111000 (19) (fase 3)
            case 356:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider D1 1011111011100001001 (19) (fase 4)
            case 357:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider D1 1111101110000100110 (19) (fase 1)
            case 358:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider D1 1000111010001101111 (19) (fase 2)
            case 359:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider D1 1001101110011111000 (19) (fase 3)
            case 360:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider D1 1011111010110001001 (19) (fase 4)
            case 361:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;

		// glider D2 11111000010 (11) (fase 1)
            case 400:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;
		// glider D2 10001000111 (11) (fase 2)
            case 401:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
		// glider D2 10011001100 (11) (fase 3)
            case 402:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;
		// glider D2 10111011101 (11) (fase 4)
            case 403:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
		// glider D2 1111101110111111000100110 (25) (fase 1)
            case 404:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                posY = posY + 25;
                break;
		// glider D2 1000111011100001001101111 (25) (fase 2)
            case 405:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                posY = posY + 25;
                break;
		// glider D2 1001101110100011011111000 (25) (fase 3)
            case 406:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                posY = posY + 25;
                break;
		// glider D2 1011111011100111110001001 (25) (fase 4)
            case 407:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                posY = posY + 25;
                break;
		// glider D2 11111011100 (11) (fase 1)
            case 408:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;
		// glider D2 10001110101 (11) (fase 2)
            case 409:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
		// glider D2 10011011111 (11) (fase 3)
            case 410:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                posY = posY + 11;
                break;
		// glider D2 10111110000 (11) (fase 4)
            case 411:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                posY = posY + 11;
                break;

		// glider E 1111100000000100110 (19) (fase 1)
            case 450:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1000100000001101111 (19) (fase 2)
            case 451:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider E 1001100000011111000 (19) (fase 3)
            case 452:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1011100000110001001 (19) (fase 4)
            case 453:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider E 1111101000011100110 (19) (fase 1)
            case 454:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1000111000110101111 (19) (fase 2)
            case 455:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider E 1001101001111111000 (19) (fase 3)
            case 456:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1011111011000001001 (19) (fase 4)
            case 457:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider E 1111101100000100110 (19) (fase 1)
            case 458:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1000111100001101111 (19) (fase 2)
            case 459:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider E 1001100100011111000 (19) (fase 3)
            case 460:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1011101100110001001 (19) (fase 4)
            case 461:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider E 1111101111011100110 (19) (fase 1)
            case 462:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1000111001110101111 (19) (fase 2)
            case 463:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;
		// glider E 1001101011011111000 (19) (fase 3)
            case 464:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                posY = posY + 19;
                break;
		// glider E 1011111111110001001 (19) (fase 4)
            case 465:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                posY = posY + 19;
                break;

                // glider E-bar 111110000100011111010 (21) (fase 1)
            case 500:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100010001100110001111 (21) (fase 2)
            case 501:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110011101110011000 (21) (fase 3)
            case 502:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101110110111010111001 (21) (fase 4)
            case 503:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 111110111111011111010 (21) (fase 1)
            case 504:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100011100001110001111 (21) (fase 2)
            case 505:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110100011010011000 (21) (fase 3)
            case 506:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101111100111110111001 (21) (fase 4)
            case 507:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 111110001011000111010 (21) (fase 1)
            case 508:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100010011111001101111 (21) (fase 2)
            case 509:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110110001011111000 (21) (fase 3)
            case 510:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101111110011110001001 (21) (fase 4)
            case 511:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 111110000101100100110 (21) (fase 1)
            case 512:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100010001111101101111 (21) (fase 2)
            case 513:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110011000111111000 (21) (fase 3)
            case 514:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101110111001100001001 (21) (fase 4)
            case 515:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 111110111010111000110 (21) (fase 1)
            case 516:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100011101111101001111 (21) (fase 2)
            case 517:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110111000111011000 (21) (fase 3)
            case 518:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101111101001101111001 (21) (fase 4)
            case 519:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 111110100110111100110 (21) (fase 1)
            case 520:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100011101111100101111 (21) (fase 2)
            case 521:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110111000101111000 (21) (fase 3)
            case 522:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101111101001111001001 (21) (fase 4)
            case 523:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 111110100111100100110 (21) (fase 1)
            case 524:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100011101100101101111 (21) (fase 2)
            case 525:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110111101111111000 (21) (fase 3)
            case 526:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101111100111000001001 (21) (fase 4)
            case 527:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 111110001011010000110 (21) (fase 1)
            case 528:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 100010011111110001111 (21) (fase 2)
            case 529:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;
		// glider E-bar 100110110000010011000 (21) (fase 3)
            case 530:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                posY = posY + 21;
                break;
		// glider E-bar 101111110000110111001 (21) (fase 4)
            case 531:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                posY = posY + 21;
                break;

                // glider F 111110001011010 (15) (fase 1)
            case 550:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 100010011111111 (15) (fase 2)
            case 551:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 100110110000000 (15) (fase 3)
            case 552:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 101111110000001 (15) (fase 4)
            case 553:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 111110000100000 (15) (fase 1)
            case 554:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 100010001100001 (15) (fase 2)
            case 555:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 100110011100011 (15) (fase 3)
            case 556:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 101110110100110 (15) (fase 4)
            case 557:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 11111011111101111111000100110 (29) (fase 1)
            case 558:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10001110000111000001001101111 (29) (fase 2)
            case 559:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 10011010001101000011011111000 (29) (fase 3)
            case 560:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10111110011111000111110001001 (29) (fase 4)
            case 561:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 11111000101100010011000100110 (29) (fase 1)
            case 562:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10001001111100110111001101111 (29) (fase 2)
            case 563:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 10011011000101111101011111000 (29) (fase 3)
            case 564:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10111111001111000111110001001 (29) (fase 4)
            case 565:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 11111000010110010011000100110 (29) (fase 1)
            case 566:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10001000111110110111001101111 (29) (fase 2)
            case 567:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 10011001100011111101011111000 (29) (fase 3)
            case 568:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10111011100110000111110001001 (29) (fase 4)
            case 569:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 11111011101011100011000100110 (29) (fase 1)
            case 570:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10001110111110100111001101111 (29) (fase 2)
            case 571:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 10011011100011101101011111000 (29) (fase 3)
            case 572:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10111110100110111111110001001 (29) (fase 4)
            case 573:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 11111010011011111111000100110 (29) (fase 1)
            case 574:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10001110111110000001001101111 (29) (fase 2)
            case 575:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 10011011100010000011011111000 (29) (fase 3)
            case 576:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                posY = posY + 29;
                break;
		// glider F 10111110100110000111110001001 (29) (fase 4)
            case 577:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                posY = posY + 29;
                break;
		// glider F 111110100110000 (15) (fase 1)
            case 578:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 100011101110001 (15) (fase 2)
            case 579:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 100110111010011 (15) (fase 3)
            case 580:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 101111101110110 (15) (fase 4)
            case 581:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 111110111011010 (15) (fase 1)
            case 582:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 100011101111111 (15) (fase 2)
            case 583:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 100110111000000 (15) (fase 3)
            case 584:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 101111101000001 (15) (fase 4)
            case 585:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 111110100000110 (15) (fase 1)
            case 586:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 100011100001111 (15) (fase 2)
            case 587:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;
		// glider F 100110100011000 (15) (fase 3)
            case 588:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                posY = posY + 15;
                break;
		// glider F 101111100111001 (15) (fase 4)
            case 589:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                posY = posY + 15;
                break;

		// glider G 111110100111110011100110 (24) (fase 1)
            case 600:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100011101100010110101111 (24) (fase 2)
            case 601:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110111100111111111000 (24) (fase 3)
            case 602:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 101111100101100000001001 (24) (fase 4)
            case 603:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 111110001011111000000110 (24) (fase 1)
            case 604:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100010011110001000001111 (24) (fase 2)
            case 605:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110110010011000011000 (24) (fase 3)
            case 606:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 101111110110111000111001 (24) (fase 4)
            case 607:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 111110000111111010011010 (24) (fase 1)
            case 608:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100010001100001110111111 (24) (fase 2)
            case 609:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110011100011011100000 (24) (fase 3)
            case 610:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 101110110100111110100001 (24) (fase 4)
            case 611:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 111110111111011000111000 (24) (fase 1)
            case 612:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100011100001111001101001 (24) (fase 2)
            case 613:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110100011001011111011 (24) (fase 3)
            case 614:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 101111100111011110001110 (24) (fase 4)
            case 615:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 111110001011011100100110 (24) (fase 1)
            case 616:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100010011111110101101111 (24) (fase 2)
            case 617:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110110000011111111000 (24) (fase 3)
            case 618:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 101111110000110000001001 (24) (fase 4)
            case 619:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 111110000100011100000110 (24) (fase 1)
            case 620:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100010001100110100001111 (24) (fase 2)
            case 621:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110011101111100011000 (24) (fase 3)
            case 622:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 101110110111000100111001 (24) (fase 4)
            case 623:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 111110111111010011011010 (24) (fase 1)
            case 624:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100011100001110111111111 (24) (fase 2)
            case 625:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110100011011100000000 (24) (fase 3)
            case 626:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 101111100111110100000001 (24) (fase 4)
            case 627:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 111110001011000111000000 (24) (fase 1)
            case 628:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100010011111001101000001 (24) (fase 2)
            case 629:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110110001011111000011 (24) (fase 3)
            case 630:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 101111110011110001000110 (24) (fase 4)
            case 631:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 11111000010110010011001111111000100110 (38) (fase 1)
            case 632:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                posY = posY + 38;
                break;
		// glider G 10001000111110110111011000001001101111 (38) (fase 2)
            case 633:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                posY = posY + 38;
                break;
		// glider G 10011001100011111101111000011011111000 (38) (fase 3)
            case 634:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                posY = posY + 38;
                break;
		// glider G 10111011100110000111001000111110001001 (38) (fase 4)
            case 635:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                posY = posY + 38;
                break;
		// glider G 11111011101011100011010110011000100110 (38) (fase 1)
            case 636:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                posY = posY + 38;
                break;
		// glider G 10001110111110100111111110111001101111 (38) (fase 2)
            case 637:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                posY = posY + 38;
                break;
		// glider G 10011011100011101100000011101011111000 (38) (fase 3)
            case 638:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                posY = posY + 38;
                break;
		// glider G 10111110100110111100000110111110001001 (38) (fase 4)
            case 639:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                posY = posY + 38;
                break;
		// glider G 111110100110111100000110 (24) (fase 1)
            case 640:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 100011101111100100001111 (24) (fase 2)
            case 641:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;
		// glider G 100110111000101100011000 (24) (fase 3)
            case 642:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
		// glider G 101111101001111100111001 (24) (fase 4)
            case 643:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                posY = posY + 24;
                break;

		// glider H 11111000101100000000111110001001101001111111000100110 (53) (fase 1)
            case 650:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001001111100000001100010011011111011000001001101111 (53) (fase 2)
            case 651:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011011000100000011100110111110001111000011011111000 (53) (fase 3)
            case 652:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111111001100000110101111100010011001000111110001001 (53) (fase 4)
            case 653:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 11111000010111000011111110001001101110110011000100110 (53) (fase 1)
            case 654:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001000111101000110000010011011111011110111001101111 (53) (fase 2)
            case 655:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011001100111001110000110111110001110011101011111000 (53) (fase 3)
            case 656:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111011101101011010001111100010011010110111110001001 (53) (fase 4)
            case 657:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 11111011101111111111100110001001101111111111000100110 (53) (fase 1)
            case 658:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001110111000000000101110011011111000000001001101111 (53) (fase 2)
            case 659:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011011101000000001111010111110001000000011011111000 (53) (fase 3)
            case 660:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111110111000000011001111100010011000000111110001001 (53) (fase 4)
            case 661:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 111110111000000011001111100010011000000 (39) (fase 1)
            case 662:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011101000000111011000100110111000001 (39) (fase 2)
            case 663:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110111000001101111001101111101000011 (39) (fase 3)
            case 664:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 101111101000011111001011111000111000110 (39) (fase 4)
            case 665:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 111110100001111100101111100011100011010 (39) (fase 1)
            case 666:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011100011000101111000100110100111111 (39) (fase 2)
            case 667:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110100111001111001001101111101100000 (39) (fase 3)
            case 668:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101111101101011001011011111000111100001 (39) (fase 4)
            case 669:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110110101100101101111100011110000110 (39) (fase 1)
            case 670:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011111111101111111000100110010001111 (39) (fase 2)
            case 671:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110000000111000001001101110110011000 (39) (fase 3)
            case 672:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101110000001101000011011111011110111001 (39) (fase 4)
            case 673:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110100000111110001111100011100111010 (39) (fase 1)
            case 674:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011100001100010011000100110101101111 (39) (fase 2)
            case 675:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110100011100110111001101111111111000 (39) (fase 3)
            case 676:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101111100110101111101011111000000001001 (39) (fase 4)
            case 677:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110001011111110001111100010000000110 (39) (fase 1)
            case 678:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100010011110000010011000100110000001111 (39) (fase 2)
            case 679:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110110010000110111001101110000011000 (39) (fase 3)
            case 680:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101111110110001111101011111010000111001 (39) (fase 4)
            case 681:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110000111100110001111100011100011010 (39) (fase 1)
            case 682:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100010001100101110011000100110100111111 (39) (fase 2)
            case 683:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110011101111010111001101111101100000 (39) (fase 3)
            case 684:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101110110111001111101011111000111100001 (39) (fase 4)
            case 685:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110111111010110001111100010011001000 (39) (fase 1)
            case 686:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011100001111110011000100110111011001 (39) (fase 2)
            case 687:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110100011000010111001101111101111011 (39) (fase 3)
            case 688:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 101111100111000111101011111000111001110 (39) (fase 4)
            case 689:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 111110001011010011001111100010011010110 (39) (fase 1)
            case 690:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100010011111110111011000100110111111111 (39) (fase 2)
            case 691:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110110000011101111001101111100000000 (39) (fase 3)
            case 692:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101111110000110111001011111000100000001 (39) (fase 4)
            case 693:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110000100011111010111100010011000000 (39) (fase 1)
            case 694:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100010001100110001111100100110111000001 (39) (fase 2)
            case 695:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110011101110011000101101111101000011 (39) (fase 3)
            case 696:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 101110110111010111001111111000111000110 (39) (fase 4)
            case 697:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 11111011111101111101011000001001101001111111000100110 (53) (fase 1)
            case 698:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001110000111000111111000011011111011000001001101111 (53) (fase 2)
            case 699:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011010001101001100001000111110001111000011011111000 (53) (fase 3)
            case 700:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111110011111011100011001100010011001000111110001001 (53) (fase 4)
            case 701:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 11111000101100011101001110111001101110110011000100110 (53) (fase 1)
            case 702:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001001111100110111011011101011111011110111001101111 (53) (fase 2)
            case 703:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011011000101111101111110111110001110011101011111000 (53) (fase 3)
            case 704:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111111001111000111000011100010011010110111110001001 (53) (fase 4)
            case 705:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 11111000010110010011010001101001101111111111000100110 (53) (fase 1)
            case 706:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001000111110110111110011111011111000000001001101111 (53) (fase 2)
            case 707:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011001100011111100010110001110001000000011011111000 (53) (fase 3)
            case 708:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111011100110000100111110011010011000000111110001001 (53) (fase 4)
            case 709:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 11111011101011100011011000101111101110000011000100110 (53) (fase 1)
            case 710:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001110111110100111111001111000111010000111001101111 (53) (fase 2)
            case 711:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011011100011101100001011001001101110001101011111000 (53) (fase 3)
            case 712:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111110100110111100011111011011111010011111110001001 (53) (fase 4)
            case 713:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 11111010011011110001111101101111101001111111000100110 (53) (fase 1)
            case 714:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 0;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10001110111110010011000111111000111011000001001101111 (53) (fase 2)
            case 715:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 0;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 0;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 1;
                initial_ring[posY+51] = 1;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;
		// glider H 10011011100010110111001100001001101111000011011111000 (53) (fase 3)
            case 716:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 0;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 0;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 1;
                initial_ring[posY+47] = 1;
                initial_ring[posY+48] = 1;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 0;
                posY = posY + 53;
                break;
		// glider H 10111110100111111101011100011011111001000111110001001 (53) (fase 4)
            case 717:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 0;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 1;
                initial_ring[posY+43] = 1;
                initial_ring[posY+44] = 1;
                initial_ring[posY+45] = 1;
                initial_ring[posY+46] = 0;
                initial_ring[posY+47] = 0;
                initial_ring[posY+48] = 0;
                initial_ring[posY+49] = 1;
                initial_ring[posY+50] = 0;
                initial_ring[posY+51] = 0;
                initial_ring[posY+52] = 1;
                posY = posY + 53;
                break;

		// glider H 111110100111111101011100011011111001000 (39) (fase 1)
            case 718:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011101100000111110100111110001011001 (39) (fase 2)
            case 719:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110111100001100011101100010011111011 (39) (fase 3)
            case 720:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 101111100100011100110111100110110001110 (39) (fase 4)
            case 721:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 111110001011001101011111001011111100110 (39) (fase 1)
            case 722:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100010011111011111110001011110000101111 (39) (fase 2)
            case 723:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110110001110000010011110010001111000 (39) (fase 3)
            case 724:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101111110011010000110110010110011001001 (39) (fase 4)
            case 725:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110000101111100011111101111101110110 (39) (fase 1)
            case 726:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100010001111000100110000111000111011111 (39) (fase 2)
            case 727:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110011001001101110001101001101110000 (39) (fase 3)
            case 728:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101110111011011111010011111011111010001 (39) (fase 4)
            case 729:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110111011111100011101100011100011100 (39) (fase 1)
            case 730:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011101110000100110111100110100110101 (39) (fase 2)
            case 731:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110111010001101111100101111101111111 (39) (fase 3)
            case 732:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 101111101110011111000101111000111000000 (39) (fase 4)
            case 733:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 111110111001111100010111100011100000010 (39) (fase 1)
            case 734:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011101011000100111100100110100000111 (39) (fase 2)
            case 735:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110111111001101100101101111100001100 (39) (fase 3)
            case 736:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101111100001011111101111111000100011101 (39) (fase 4)
            case 737:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110000101111110111111100010001110110 (39) (fase 1)
            case 738:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100010001111000011100000100110011011111 (39) (fase 2)
            case 739:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 0;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110011001000110100001101110111110000 (39) (fase 3)
            case 740:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101110111011001111100011111011100010001 (39) (fase 4)
            case 741:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 0;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 111110111011110110001001100011101001100 (39) (fase 1)
            case 742:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011101110011110011011100110111011101 (39) (fase 2)
            case 743:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110111010110010111110101111101110111 (39) (fase 3)
            case 744:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 101111101111110111100011111000111011100 (39) (fase 4)
            case 745:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 111110111111011110001111100011101110010 (39) (fase 1)
            case 746:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 100011100001110010011000100110111010111 (39) (fase 2)
            case 747:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;
		// glider H 100110100011010110111001101111101111100 (39) (fase 3)
            case 748:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 0;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 0;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 0;
                posY = posY + 39;
                break;
		// glider H 101111100111111111101011111000111000101 (39) (fase 4)
            case 749:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 0;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 0;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 0;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 0;
                initial_ring[posY+38] = 1;
                posY = posY + 39;
                break;

            // glider gun 111011011100100110101100000 (27)
            case 750:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 0;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 0;
                initial_ring[posY+25] = 0;
                initial_ring[posY+26] = 0;
                posY = posY + 27;
                break;

// 2A 111110100110 (12) (phase 1)
            case 2000:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                posY = posY + 12;
                break;
// 3A 111110111000100110 (18) (phase 1)
            case 2001:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 0;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 0;
                posY = posY + 18;
                break;
// 4A 1111101110 (10) (phase 1)
            case 2002:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                posY = posY + 10;
                break;
// 5A 1111101110100110 (16) (phase 1)
            case 2003:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                posY = posY + 16;
                break;

// 2B 1111101011100110 (16) (phase 1)
            case 2010:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                posY = posY + 16;
                break;
// 3B 1110011000 (10) (phase 1)
            case 2011:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 0;
                initial_ring[posY+4] = 0;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 0;
                initial_ring[posY+9] = 0;
                posY = posY + 10;
                break;
// 4B 111110101110011000 (18) (phase 1)
            case 2012:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                posY = posY + 18;
                break;
// 5B 11111010111001100011111010 (26) (phase 1)
            case 2013:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 0;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 0;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 0;
                posY = posY + 26;
                break;

// 2D2 111110111000011101110110 (24) (phase 1)
            case 2060:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                posY = posY + 24;
                break;
// 3D2 1111101110000111011101101110001111 000100110 (43) (phase 1)
            case 2061:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 0;
                initial_ring[posY+10] = 0;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 0;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 0;
                initial_ring[posY+28] = 0;
                initial_ring[posY+29] = 0;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 0;
                initial_ring[posY+35] = 0;
                initial_ring[posY+36] = 0;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 0;
                initial_ring[posY+39] = 0;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                initial_ring[posY+42] = 0;
                posY = posY + 43;
                break;

// E2 111110001110001101011100110 (27) (phase 1)
            case 2080:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 0;
                initial_ring[posY+6] = 0;
                initial_ring[posY+7] = 0;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 0;
                initial_ring[posY+12] = 0;
                initial_ring[posY+13] = 0;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 0;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 0;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 0;
                initial_ring[posY+23] = 0;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 0;
                posY = posY +27;
                break;

// T40
            case 3000:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                posY = posY + 40;
                break;
// T41
            case 3001:
                initial_ring[posY] = 1;
                initial_ring[posY+1] = 1;
                initial_ring[posY+2] = 1;
                initial_ring[posY+3] = 1;
                initial_ring[posY+4] = 1;
                initial_ring[posY+5] = 1;
                initial_ring[posY+6] = 1;
                initial_ring[posY+7] = 1;
                initial_ring[posY+8] = 1;
                initial_ring[posY+9] = 1;
                initial_ring[posY+10] = 1;
                initial_ring[posY+11] = 1;
                initial_ring[posY+12] = 1;
                initial_ring[posY+13] = 1;
                initial_ring[posY+14] = 1;
                initial_ring[posY+15] = 1;
                initial_ring[posY+16] = 1;
                initial_ring[posY+17] = 1;
                initial_ring[posY+18] = 1;
                initial_ring[posY+19] = 1;
                initial_ring[posY+20] = 1;
                initial_ring[posY+21] = 1;
                initial_ring[posY+22] = 1;
                initial_ring[posY+23] = 1;
                initial_ring[posY+24] = 1;
                initial_ring[posY+25] = 1;
                initial_ring[posY+26] = 1;
                initial_ring[posY+27] = 1;
                initial_ring[posY+28] = 1;
                initial_ring[posY+29] = 1;
                initial_ring[posY+30] = 1;
                initial_ring[posY+31] = 1;
                initial_ring[posY+32] = 1;
                initial_ring[posY+33] = 1;
                initial_ring[posY+34] = 1;
                initial_ring[posY+35] = 1;
                initial_ring[posY+36] = 1;
                initial_ring[posY+37] = 1;
                initial_ring[posY+38] = 1;
                initial_ring[posY+39] = 1;
                initial_ring[posY+40] = 1;
                initial_ring[posY+41] = 1;
                posY = posY + 41;
                break;
// T42
           case 3002:
               initial_ring[posY] = 1;
               initial_ring[posY+1] = 1;
               initial_ring[posY+2] = 1;
               initial_ring[posY+3] = 1;
               initial_ring[posY+4] = 1;
               initial_ring[posY+5] = 1;
               initial_ring[posY+6] = 1;
               initial_ring[posY+7] = 1;
               initial_ring[posY+8] = 1;
               initial_ring[posY+9] = 1;
               initial_ring[posY+10] = 1;
               initial_ring[posY+11] = 1;
               initial_ring[posY+12] = 1;
               initial_ring[posY+13] = 1;
               initial_ring[posY+14] = 1;
               initial_ring[posY+15] = 1;
               initial_ring[posY+16] = 1;
               initial_ring[posY+17] = 1;
               initial_ring[posY+18] = 1;
               initial_ring[posY+19] = 1;
               initial_ring[posY+20] = 1;
               initial_ring[posY+21] = 1;
               initial_ring[posY+22] = 1;
               initial_ring[posY+23] = 1;
               initial_ring[posY+24] = 1;
               initial_ring[posY+25] = 1;
               initial_ring[posY+26] = 1;
               initial_ring[posY+27] = 1;
               initial_ring[posY+28] = 1;
               initial_ring[posY+29] = 1;
               initial_ring[posY+30] = 1;
               initial_ring[posY+31] = 1;
               initial_ring[posY+32] = 1;
               initial_ring[posY+33] = 1;
               initial_ring[posY+34] = 1;
               initial_ring[posY+35] = 1;
               initial_ring[posY+36] = 1;
               initial_ring[posY+37] = 1;
               initial_ring[posY+38] = 1;
               initial_ring[posY+39] = 1;
               initial_ring[posY+40] = 1;
               initial_ring[posY+41] = 1;
               initial_ring[posY+42] = 1;
               posY = posY + 42;
               break;

// line personal 11111000111000100110-20
           case 2120:
               initial_ring[posY] = 1;
               initial_ring[posY+1] = 1;
               initial_ring[posY+2] = 1;
               initial_ring[posY+3] = 1;
               initial_ring[posY+4] = 1;
               initial_ring[posY+5] = 0;
               initial_ring[posY+6] = 0;
               initial_ring[posY+7] = 0;
               initial_ring[posY+8] = 1;
               initial_ring[posY+9] = 1;
               initial_ring[posY+10] = 1;
               initial_ring[posY+11] = 0;
               initial_ring[posY+12] = 0;
               initial_ring[posY+13] = 0;
               initial_ring[posY+14] = 1;
               initial_ring[posY+15] = 0;
               initial_ring[posY+16] = 0;
               initial_ring[posY+17] = 1;
               initial_ring[posY+18] = 1;
               initial_ring[posY+19] = 0;
               posY = posY + 20;
               break;

// line personal 1111100010011011101000110-
           case 2121:
               initial_ring[posY] = 1;
               initial_ring[posY+1] = 1;
               initial_ring[posY+2] = 1;
               initial_ring[posY+3] = 1;
               initial_ring[posY+4] = 1;
               initial_ring[posY+5] = 0;
               initial_ring[posY+6] = 0;
               initial_ring[posY+7] = 0;
               initial_ring[posY+8] = 1;
               initial_ring[posY+9] = 0;
               initial_ring[posY+10] = 0;
               initial_ring[posY+11] = 1;
               initial_ring[posY+12] = 1;
               initial_ring[posY+13] = 0;
               initial_ring[posY+14] = 1;
               initial_ring[posY+15] = 1;
               initial_ring[posY+16] = 1;
               initial_ring[posY+17] = 0;
               initial_ring[posY+18] = 1;
               initial_ring[posY+19] = 0;
               initial_ring[posY+20] = 0;
               initial_ring[posY+21] = 0;
               initial_ring[posY+22] = 1;
               initial_ring[posY+23] = 1;
               initial_ring[posY+24] = 0;
               posY = posY + 25;
               break;

// line personal 111110011111011100110-21
           case 2122:
               initial_ring[posY] = 1;
               initial_ring[posY+1] = 1;
               initial_ring[posY+2] = 1;
               initial_ring[posY+3] = 1;
               initial_ring[posY+4] = 1;
               initial_ring[posY+5] = 0;
               initial_ring[posY+6] = 0;
               initial_ring[posY+7] = 1;
               initial_ring[posY+8] = 1;
               initial_ring[posY+9] = 1;
               initial_ring[posY+10] = 1;
               initial_ring[posY+11] = 1;
               initial_ring[posY+12] = 0;
               initial_ring[posY+13] = 1;
               initial_ring[posY+14] = 1;
               initial_ring[posY+15] = 1;
               initial_ring[posY+16] = 0;
               initial_ring[posY+17] = 0;
               initial_ring[posY+18] = 1;
               initial_ring[posY+19] = 1;
               initial_ring[posY+20] = 0;
               posY = posY + 21;
               break;

          }
      }
}

@end
